//-----------------------------------------------------------------------------
// sysdep.h : RpCˑ
// Copyright (c) 2005-2008  N099
//-----------------------------------------------------------------------------
#pragma once

#include <emmintrin.h>

#if defined( _WIN32 ) || defined( _WIN64 )
#include <windows.h>
typedef SHORT int16_t;
typedef INT   int32_t;

#elif defined( _GNU_C )
#include <stdint.h>
#endif

#if defined( _MSC_VER ) && _MSC_VER >= 1400
#define InterlockedExchangeAdd _InterlockedExchangeAdd
#define restrict __restrict
#define NOA __declspec(noalias)
#elif defined( _GNU_C )
#define NOA
#else
#define restrict
#define NOA
#endif

#ifdef __cplusplus
extern "C" {
#endif

typedef const int16_t * restrict pint16c;
typedef int16_t * restrict pint16r;
typedef const __m64 * restrict p_m64c;
typedef __m64 * restrict p_m64r;
typedef const __m128i * restrict p_m128c;
typedef __m128i * restrict p_m128r;

// ʒu킹pp
typedef union _u64_i32 {
    int32_t i[2];
    __m64 m;
} u64_i32;

typedef union _u64_i16 {
    int16_t i[4];
    __m64 m;
} u64_i16;

typedef union _u128i_i32 {
    int32_t i[4];
    __m128i x;
} u128i_i32;

typedef union _u128i_i16 {
    int16_t i[8];
    __m128i x;
} u128i_i16;


#ifdef __cplusplus
}
#endif

